// робот рисовальщик - управление ИК пультом от триколор
#include <Servo.h>
#include <IRremote.h>
//
#define plus A2 //
#define minus A1 //
int RECV_PIN = A0;               // Pin, an den der Empf�nger angeschlossen ist
IRrecv irrecv(RECV_PIN);         // Instanz der Receiver-Klasse
decode_results results;          // Zur Aufnahme des ermittelsten Codes
/////////
long Y=0;//переменная хранения моментов времени
byte FLAG=0;//
int k=0;//переменная хранения и записи числовых данных по углу и дистанции
int kk=0;//переменная хранения и записи числовых данных по углу при рисовании дуги
// setup servo
int servoPin = 8;
int PEN_DOWN = 80; // angle of servo when pen is down
int PEN_UP = 20;   // angle of servo when pen is up
Servo penServo;

//float wheel_dia=66.0; //    # mm (increase = spiral out)
//float wheel_base=110.0; //    # mm (increase = spiral in, ccw) 
//int steps_rev=512; //        # 512 for 64x gearbox, 128 for 16x gearbox
int delay_time=4; //         # time between steps in ms

// Stepper sequence org->pink->blue->yel (оранжевый,розовый,синий,жёлтый)
int L_stepper_pins[] = {12, 10, 9, 11};
int R_stepper_pins[] = {4, 6, 7, 5};

int fwd_mask[][4] =  {{1, 0, 1, 0},
                      {0, 1, 1, 0},
                      {0, 1, 0, 1},
                      {1, 0, 0, 1}};

int rev_mask[][4] =  {{1, 0, 0, 1},
                      {0, 1, 0, 1},
                      {0, 1, 1, 0},
                      {1, 0, 1, 0}};


void setup() {
   irrecv.enableIRIn(); // Startet den Receiver
 // randomSeed(analogRead(1)); 
 // Serial.begin(9600);
  for(int pin=0; pin<4; pin++){
    pinMode(L_stepper_pins[pin], OUTPUT);
    digitalWrite(L_stepper_pins[pin], LOW);
    pinMode(R_stepper_pins[pin], OUTPUT);
    digitalWrite(R_stepper_pins[pin], LOW);
  }
pinMode(plus,OUTPUT);//
digitalWrite(plus,HIGH);// плюс питания ик приёмника
pinMode(minus,OUTPUT);//
digitalWrite(minus,LOW);// минус питания ик приёмника

  penServo.attach(servoPin);
   penServo.write(PEN_UP);
  //Serial.println("setup");
 // penup();//вверх маркер
 // delay(2000);
}


void loop(){ 
  ///////////////////////////////////
  if (irrecv.decode(&results))   //Если произошло событие/кнопка была нажата
  {
    switch ( results.value )
    {
   //////////////////////////
    case 0x8A857://исполнить команду вперёд
  if(k==0){
   FLAG=1;
      Y=millis();}
      else{backward(k);k=0;done();}  
        break;
     case 0x88877://исполнить команду назад
   if(k==0){
    FLAG=2; 
      Y=millis();}
      else{ forward(k);k=0;done();}   
        break;  
      case  0x848B7://исполнить команду вправо
   if(k==0){
     FLAG=3;
      Y=millis();}
      else{left(k);k=0;done();}   
        break; 
   case  0x828D7://исполнить команду влево
   if(k==0){
     FLAG=4;
      Y=millis();}
      else{right(k);k=0;done();}   
        break;             
     case 0xFFFFFFFF:// если кнопку удерживают, то не отключать команду ещё 200 мс
      Y=millis();
        break;
    ///////другая вариация пульта 
     case  0x8B04F://рисовать дугу вправо вперёд
   if(k!=0&&kk!=0){
    duga(k,kk,1,1);k=0;kk=0;} 
    break;
     case  0x818E7://рисовать дугу влево вперёд
   if(k!=0&&kk!=0){
    duga(k,kk,1,0);k=0;kk=0;} 
    break;
     case  0x86897://рисовать дугу вправо назад
   if(k!=0&&kk!=0){
    duga(k,kk,0,0);k=0;kk=0;} 
    break;
     case 0x8827D://рисовать дугу влево назад
   if(k!=0&&kk!=0){
    duga(k,kk,0,1);k=0;kk=0;} 
    break;                     
     ////////////////////////////
     case 0x8C837://кнопка OK - управление маркером
      if( penServo.read()==PEN_DOWN){ penup();}//вверх маркер
      else{
      if(penServo.read()==PEN_UP){ pendown();}//вниз маркер
      }
        break; 
     ////////////////////////////
      case 0x8C03F://кнопка 1
      k=10*k+1;if(k>999){k=0;}delay(250);
        break;
    case 0x820DF://кнопка 2
     k=10*k+2;if(k>999){k=0;}delay(250);
        break;
    case 0x8A05F://кнопка 3
     k=10*k+3;if(k>999){k=0;}delay(250);
        break;
    case 0x8609F://кнопка 4
    k=10*k+4;if(k>999){k=0;}delay(250);
        break;
    case 0x8E01F://кнопка 5
   k=10*k+5;if(k>999){k=0;}delay(250);
        break;
    case 0x810EF://кнопка 6
     k=10*k+6;if(k>999){k=0;}delay(250);
        break;
      case 0x8906F://кнопка 7
     k=10*k+7;if(k>999){k=0;}delay(250);
        break;
   case 0x850AF://кнопка 8
     k=10*k+8;if(k>999){k=0;}delay(250);  
        break;
   case 0x8D02F://кнопка 9
     k=10*k+9;if(k>999){k=0;}delay(250);
        break;
     case 0x830CF://кнопка 0
     k=10*k+0;if(k>999){k=0;}delay(250);  
        break;        
    /////////////////////////// 
     case 0x838C7://кнопка красная - рисование выбранного изображения
     if(k==1){zvezda();k=0;}//рис.пятиконечная звезда
     if(k==2){okrugnost();k=0;}//рис. окружность
     if(k==3){ elka();k=0;}//рис. ёлка
     if(k==4){lucha();k=0;}//рис. 4 луча-звезда
     if(k==5){ uzor();k=0;}//рис. спираль-узор
     if(k==6){ zvetok();k=0;}//рис. спираль-узор
     if(k==7){ serdze();k=0;}//рис.сердце
     if(k==8){ kub();k=0;}//рис.куб
     if(k==9){ komanda();k=0;}//рис.из приложения код котик
     if(k==10){ komanda_2();k=0;}//рис.из приложения код конь шахм.
     if(k==11){ komanda_3();k=0;}//рис.из приложения код лампочка
     if(k==12){ komanda_4();k=0;}//рис.из приложения код ракета
     if(k==13){ komanda_5();k=0;}//рис.из приложения код собака
     if(k==14){ komanda_6();k=0;}//рис.из приложения код девушка
     if(k==15){ komanda_7();k=0;}//рис.из приложения код цветок
        break;    
     case 0x8B847://кнопка зелёная - внесение данных по углу поворота при командном рисовании дуги
    kk=k;k=0;delay(250);
        break;        
     case 0x858A7://кнопка жёлтая 
     //
        break;        
      case 0x87887://кнопка синяя 
    //
        break;                    
    ///////////////////////////          
    }
    irrecv.resume();//Считываем следующую значение/кнопку
   }
   if(millis()-Y>200){ FLAG=0;}//если кнопка не удерживается, то через 200 мс отключить команду  
  ///////////////////////////////////
  for(int mask=0; mask<4; mask++){
      for(int pin=0; pin<4; pin++){
        if(FLAG==2){
        digitalWrite(L_stepper_pins[pin], fwd_mask[mask][pin]);
        digitalWrite(R_stepper_pins[pin], rev_mask[mask][pin]);
           } 
         if(FLAG==1){
        digitalWrite(L_stepper_pins[pin], rev_mask[mask][pin]);
        digitalWrite(R_stepper_pins[pin], fwd_mask[mask][pin]);
           } 
         if(FLAG==4){
        digitalWrite(R_stepper_pins[pin], fwd_mask[mask][pin]);
        digitalWrite(L_stepper_pins[pin], fwd_mask[mask][pin]);
           } 
         if(FLAG==3){
        digitalWrite(R_stepper_pins[pin], rev_mask[mask][pin]);
        digitalWrite(L_stepper_pins[pin], rev_mask[mask][pin]);
           }       
         if(FLAG==0){
        digitalWrite(R_stepper_pins[pin], LOW);
        digitalWrite(L_stepper_pins[pin], LOW);
           }                 
      }
      delay(delay_time);
    } 
  ///////////////////////////////////
}



///////////////////////////////////////
void forward(float distance){
 // int steps = step(distance);
    int steps =distance/0.40;
  for(int step=0; step<steps; step++){
    for(int mask=0; mask<4; mask++){
      for(int pin=0; pin<4; pin++){
        digitalWrite(L_stepper_pins[pin], fwd_mask[mask][pin]);
        digitalWrite(R_stepper_pins[pin], rev_mask[mask][pin]);
      }
      delay(delay_time);
    } 
  }
}
/////////////////////////////////////////
void  backward(float distance){
 // int steps = step(distance);
    int steps =distance/0.40;
 // Serial.println(steps);
  for(int step=0; step<steps; step++){
    for(int mask=0; mask<4; mask++){
      for(int pin=0; pin<4; pin++){
        digitalWrite(L_stepper_pins[pin], rev_mask[mask][pin]);
        digitalWrite(R_stepper_pins[pin], fwd_mask[mask][pin]);
      }
      delay(delay_time);
    } 
  }
}
//////////////////////////////////////////
void left(float degrees){
 // float rotation = degrees / 360.0;
 // float distance = wheel_base * 3.1412 * rotation;
 // int steps = step(distance);
    int steps =degrees/0.42;
  for(int step=0; step<steps; step++){
    for(int mask=0; mask<4; mask++){
      for(int pin=0; pin<4; pin++){
        digitalWrite(R_stepper_pins[pin], rev_mask[mask][pin]);
        digitalWrite(L_stepper_pins[pin], rev_mask[mask][pin]);
      }
      delay(delay_time);
    } 
  }   
}

/////////////////////////////////////////
void right(float degrees){
 // float rotation = degrees / 360.0;
 // float distance = wheel_base * 3.1412 * rotation;
 // int steps = step(distance);
  int steps =degrees/0.42;
  for(int step=0; step<steps; step++){
    for(int mask=0; mask<4; mask++){
      for(int pin=0; pin<4; pin++){
        digitalWrite(R_stepper_pins[pin], fwd_mask[mask][pin]);
        digitalWrite(L_stepper_pins[pin], fwd_mask[mask][pin]);
      }
      delay(delay_time);
    } 
  }   
}


void done(){ // unlock stepper to save battery
  for(int mask=0; mask<4; mask++){
    for(int pin=0; pin<4; pin++){
      digitalWrite(R_stepper_pins[pin], LOW);
      digitalWrite(L_stepper_pins[pin], LOW);
    }
    delay(delay_time);
  }
}
////////////////////
void penup(){//вверх маркер
  penServo.attach(servoPin);
  for(int i=PEN_DOWN;i>=PEN_UP;i--){
  penServo.write(i);
  delay(2*delay_time/1);
  }
 penServo.detach(); 
}
///////////////////
void pendown(){//вниз маркер
  penServo.attach(servoPin);
for(int i=PEN_UP;i<=PEN_DOWN;i++){
  penServo.write(i);
  delay(2*delay_time/1);
  } 
 penServo.detach(); 
}

////////////////////
void  duga(float L,float a,bool KL,bool Ka){//функция отрисовки дуги длиной L мм и углом поворота a градусов,KL=1,0-вперёд назад,Ka=1,0-вправо,влево
  
 int NL= L/0.40; int Na=a/0.42;//общее число шагов при прямолинейном движении и повороте маркера на дуге 
 //(Lш=0.40 мм; aш=0.42 градуса - прямолинейное перемещение и угол поворота маркера при одном шаге моторов )
 //Lш=3.14*d/N;aш=360*d/(N*D) где d- диаметр колеса (66мм); N-число шагов мотора на полный оборот (512);D- расстояние между колёсами (110мм)
 
 int nL=10; int na=Na*nL/NL;//число шагов моторов при прямолинейном движении и повороте для одного минишага при рисовании 
 for(int schag=0;schag<NL+Na;schag++){
 for(int mask=0; mask<4; mask++){
      for(int pin=0; pin<4; pin++){
        if(KL==1&&schag%(nL+na)<nL){//вперёд
        digitalWrite(L_stepper_pins[pin], fwd_mask[mask][pin]);
        digitalWrite(R_stepper_pins[pin], rev_mask[mask][pin]);
           }
       if(KL==0&&schag%(nL+na)<nL){//назад
        digitalWrite(L_stepper_pins[pin], rev_mask[mask][pin]);
        digitalWrite(R_stepper_pins[pin], fwd_mask[mask][pin]);
           }     
         if(Ka==1&&schag%(nL+na)>=nL){//вправо
        digitalWrite(R_stepper_pins[pin], fwd_mask[mask][pin]);
        digitalWrite(L_stepper_pins[pin], fwd_mask[mask][pin]);
           }
       if(Ka==0&&schag%(nL+na)>=nL){//влево
        digitalWrite(R_stepper_pins[pin], rev_mask[mask][pin]);
        digitalWrite(L_stepper_pins[pin], rev_mask[mask][pin]);
           }         
      }
    delay(delay_time);   
 }
  } 
               
}
////////////////////
//функции рисования готовых картинок
////////////////////
void zvezda(){
   pendown();//вниз маркер
  for(int x=0; x<5; x++){//пятиконечная звезда (версия 3)
   right(108);forward(50);left(35.5);backward(50);
  }
   penup();//вверх маркер
   done(); // отключить ток в обмотках моторов (отпустить роторы)  
}
////////////////////
void elka(){
 pendown();//вниз маркер
 left(90);forward(60); right(90);forward(30);left(90);forward(90);
 left(45);backward(84.9);right(45);forward(30);
 left(45);backward(84.9);right(45);forward(30);
 left(45);backward(84.9);
 left(90);forward(84.9);
 left(45);backward(30);right(45);forward(84.9);
 left(45);backward(30);right(45);forward(84.9);
 left(45);backward(90);
 right(90);forward(30); 
 penup();//вверх маркер
   done(); // отключить ток в обмотках моторов (отпустить роторы)  
}
////////////////////
void lucha(){
pendown();//вниз маркер
     duga(70,94,1,1);duga(70,94,0,1);duga(70,94,1,1);duga(70,94,0,1);//звездочка 4 луча 
     penup();//вверх маркер
     done(); // отключить ток в обмотках моторов (отпустить роторы)
}
////////////////////
void uzor(){
 pendown();//вниз маркер
     duga(30,180,1,1);duga(70,180,1,1);duga(120,180,1,1);//спираль-узор
     duga(100,270,1,0);
     duga(120,180,1,1);duga(70,180,1,1);duga(30,180,1,1);
     penup();//вверх маркер
     done(); // отключить ток в обмотках моторов (отпустить роторы)  
 }
 ///////////////////  
 void okrugnost(){
 pendown();//вниз маркер
  //окружность
  float N=28;float R=80;//N - число отрезков в окружности, R - радиус окружности
  float delta=0.2;//поправка, определяется экспериментально 
  for(int j=0;j<N;j++){
  right(360/N+delta);forward(2*R*sin(PI/N));  
  }
  //
  penup();//вверх маркер
  done();      // releases stepper motor  
}
///////////////////
void zvetok(){
  pendown();//вниз маркер
  left(126);
  for(int i=0;i<7;i++){//цветик семицветик
  duga(106,252,1,1);left(198);
  }
  penup();//вверх маркер
  backward(8);right(98);
  pendown();//вниз маркер
  duga(250,370,1,1);
  penup();//вверх маркер
  done(); // отключить ток в обмотках моторов (отпустить роторы)    
}
/////////////////// 
void serdze(){
  pendown();//вниз маркер
  duga(110,225,1,1);//сердечко
  left(180);
  duga(110,225,1,1);
  forward(75);right(93);forward(75);
  penup();//вверх маркер
  done(); // отключить ток в обмотках моторов (отпустить роторы)    
}
///////////////////  
void kub(){//рисуем куб
  pendown();//вниз маркер
  right(90);forward(50);right(91);forward(50);right(91);forward(50);right(91);forward(50);
  right(45);forward(35);right(46);forward(50);right(91);forward(50);right(45);forward(35); 
  penup();//вверх маркер
  left(45);backward(50);
  pendown();//вниз маркер
  right(45);backward(35);
  penup();//вверх маркер
  done(); // отключить ток в обмотках моторов (отпустить роторы)    
}
/////////////////// 
void komanda(){//котик
right(46);forward(49);
pendown();
left(69);forward(7);
right(32);forward(6);
right(29);forward(6);
left(8);forward(6);
left(30);forward(7);
left(16);forward(5);
left(85);forward(5);
right(34);forward(6);
left(8);forward(7);
left(19);forward(8);
right(39);forward(6);
right(26);forward(5);
left(4);forward(5);
left(106);forward(5);
left(41);forward(3);
right(12);forward(6);
left(22);forward(5);
left(44);forward(4);
left(142);forward(5);
left(11);forward(9);
left(103);forward(3);
left(41);forward(6);
left(17);forward(7);
left(29);forward(8);
right(37);forward(10);
left(12);forward(9);
left(35);forward(8);
left(8);forward(9);
left(14);forward(12);
right(16);forward(14);
right(31);forward(14);
right(23);forward(22);
right(20);forward(13);
right(6);forward(12);
right(3);forward(16);
left(27);forward(8);
left(10);forward(8);
left(42);forward(4);
left(25);forward(5);
left(85);forward(5);
left(58);forward(5);
right(20);forward(16);
right(18);forward(15);
right(12);forward(19);
left(8);forward(15);
left(25);forward(12);
left(54);forward(13);
left(39);forward(16);
left(21);forward(17);
left(16);forward(18);
left(11);forward(19);
left(18);forward(18);
left(25);forward(19);
left(50);forward(12);
left(37);forward(14);
left(30);forward(15);
left(28);forward(18);
left(31);forward(19);
left(29);forward(17);
left(20);forward(23);
left(17);forward(22);
right(17);forward(17);
right(22);forward(19);
right(33);forward(20);
right(33);forward(16);
right(24);forward(13);
right(30);forward(14);
right(26);forward(12);
right(48);forward(15);
right(47);forward(8);
right(24);forward(7);
right(56);forward(10);
right(81);forward(8);
right(64);forward(4);
right(76);forward(3);
right(89);forward(3);
penup();
left(94);forward(54);
done(); // отключить ток в обмотках моторов (отпустить роторы)      
}
///////////////////шахматный конь 
void komanda_2(){ 
left(79);forward(20);
pendown();
right(150);forward(12);
right(34);forward(9);
right(27);forward(10);
right(16);forward(14);
right(20);forward(13);
right(22);forward(13);
right(8);forward(14);
right(1);forward(14);
left(30);forward(12);
right(34);forward(9);
right(29);forward(11);
right(33);forward(12);
right(10);forward(19);
right(10);forward(11);
right(36);forward(11);
right(32);forward(12);
right(22);forward(10);
right(17);forward(11);
right(8);forward(12);
right(16);forward(11);
right(10);forward(8);
right(66);forward(5);
right(78);forward(5);
right(55);forward(6);
right(25);forward(11);
left(20);forward(7);
left(9);forward(9);
right(4);forward(6);
right(57);forward(6);
right(48);forward(8);
right(18);forward(7);
right(27);forward(11);
right(20);forward(7);
right(2);forward(6);
left(11);forward(11);
right(13);forward(8);
right(15);forward(8);
right(25);forward(6);
right(26);forward(8);
right(25);forward(8);
right(10);forward(11);
right(17);forward(14);
right(5);forward(13);
left(2);forward(10);
left(20);forward(12);
left(25);forward(10);
left(5);forward(8);
right(3);forward(10);
right(34);forward(7);
right(57);forward(8);
right(25);forward(15);
right(12);forward(15);
right(9);forward(15);
right(2);forward(15);
right(23);forward(11);
right(41);forward(11);
right(58);forward(11);
penup();
forward(48);
done(); // отключить ток в обмотках моторов (отпустить роторы)      
}
////////////////////////
void komanda_3(){//лампочка
right(89);forward(20);
pendown();
right(169);forward(7);
right(5);forward(8);
right(34);forward(4);
right(18);forward(4);
right(68);forward(4);
right(63);forward(9);
left(1);forward(6);
left(8);forward(7);
left(29);forward(5);
left(115);forward(6);
left(12);forward(8);
left(5);forward(11);
right(4);forward(9);
right(32);forward(6);
right(78);forward(5);
right(66);forward(10);
left(6);forward(8);
left(7);forward(9);
right(4);forward(10);
left(15);forward(6);
left(72);forward(4);
left(68);forward(6);
left(10);forward(7);
right(45);forward(7);
right(17);forward(8);
right(27);forward(9);
right(22);forward(9);
right(28);forward(8);
right(60);forward(5);
right(55);forward(6);
right(56);forward(5);
right(22);forward(5);
right(10);forward(14);
right(19);forward(20);
right(63);forward(8);
right(71);forward(4);
right(53);forward(5);
right(36);forward(7);
right(25);forward(11);
right(26);forward(8);
right(16);forward(7);
right(52);forward(11);
right(36);forward(11);
right(34);forward(10);
right(9);forward(12);
right(21);forward(10);
right(9);forward(11);
right(24);forward(8);
right(5);forward(14);
right(18);forward(12);
right(19);forward(12);
right(25);forward(11);
right(16);forward(10);
right(13);forward(15);
right(14);forward(11);
right(21);forward(9);
right(11);forward(11);
right(18);forward(9);
right(12);forward(10);
right(15);forward(10);
right(15);forward(10);
penup();
left(23);forward(42);
done(); // отключить ток в обмотках моторов (отпустить роторы)
}
///////////////////////////
void komanda_4(){//ракета
 left(132);forward(23);
pendown();
left(5);forward(12);
left(18);forward(9);
left(111);forward(8);
right(103);forward(18);
left(141);forward(17);
right(74);forward(7);
left(97);forward(19);
right(41);forward(9);
right(83);forward(14);
left(96);forward(13);
left(28);forward(12);
left(27);forward(17);
left(34);forward(16);
left(18);forward(15);
left(18);forward(18);
left(33);forward(17);
left(38);forward(11);
left(9);forward(10);
left(15);forward(13);
left(105);forward(14);
forward(10);
right(26);forward(10);
right(25);forward(10);
right(106);forward(5);
right(57);forward(7);
right(29);forward(10);
right(38);forward(16);
right(9);forward(14);
right(3);forward(16);
right(10);forward(15);
right(8);forward(15);
right(14);forward(17);
right(3);forward(10);
right(13);forward(14);
right(113);forward(19);
right(9);forward(17);
right(2);forward(16);
right(9);forward(12);
right(8);forward(11);
right(4);forward(14);
right(20);forward(21);
penup();
right(147);forward(59);
pendown();
right(49);forward(4);
left(12);forward(5);
left(44);forward(3);
left(15);forward(4);
left(35);forward(4);
left(55);forward(5);
right(7);forward(4);
left(59);forward(3);
left(12);forward(4);
left(26);forward(4);
left(41);forward(6);
penup();
right(4);forward(37);
done(); // отключить ток в обмотках моторов (отпустить роторы)  
}
////////////////////////////
void komanda_5(){//собака
 left(8);forward(13);
pendown();
right(179);forward(12);
right(22);forward(10);
right(23);forward(10);
right(35);forward(9);
right(34);forward(8);
right(26);forward(13);
right(4);forward(16);
left(16);forward(13);
left(24);forward(12);
left(40);forward(7);
left(55);forward(8);
left(26);forward(13);
left(19);forward(9);
left(7);forward(8);
right(154);forward(14);
left(16);forward(9);
left(37);forward(4);
left(82);forward(5);
left(54);forward(10);
left(5);forward(20);
left(14);forward(17);
left(28);forward(10);
left(34);forward(11);
left(33);forward(13);
left(14);forward(14);
right(2);forward(15);
left(1);forward(11);
right(6);forward(29);
right(13);forward(10);
right(20);forward(16);
left(26);forward(6);
left(56);forward(4);
left(46);forward(8);
left(34);forward(9);
left(126);forward(9);
left(25);forward(11);
left(55);forward(8);
left(42);forward(9);
left(12);forward(6);
left(37);forward(9);
right(31);forward(6);
right(6);forward(6);
left(39);forward(5);
left(49);forward(4);
left(43);forward(6);
left(21);forward(8);
left(9);forward(9);
right(41);forward(12);
right(13);forward(11);
right(1);forward(21);
left(22);forward(13);
left(17);forward(16);
right(11);forward(13);
right(8);forward(21);
right(21);forward(9);
right(39);forward(5);
left(25);forward(4);
left(53);forward(4);
left(76);forward(7);
left(25);forward(8);
left(46);forward(18);
left(5);forward(16);
left(5);forward(10);
left(2);forward(9);
left(51);forward(6);
left(87);forward(4);
left(78);forward(7);
left(7);forward(13);
left(18);forward(12);
penup();
left(27);forward(56);
done(); // отключить ток в обмотках моторов (отпустить роторы)   
}
////////////////////////////
void komanda_6(){//девушка
 right(123);forward(25);
pendown();
left(62);forward(7);
left(23);forward(8);
left(38);forward(8);
left(56);forward(9);
left(49);forward(6);
left(75);forward(4);
right(107);forward(12);
right(27);forward(12);
right(16);forward(10);
right(6);forward(12);
left(135);forward(10);
left(14);forward(12);
left(7);forward(7);
right(26);forward(6);
right(8);forward(6);
left(43);forward(3);
left(32);forward(6);
right(38);forward(9);
left(16);forward(9);
left(48);forward(6);
left(15);forward(7);
right(1);forward(6);
right(82);forward(21);
left(118);forward(34);
left(56);forward(11);
right(38);forward(13);
left(11);forward(16);
left(20);forward(18);
left(24);forward(16);
left(15);forward(17);
left(30);forward(16);
left(20);forward(21);
left(23);forward(18);
left(30);forward(15);
left(17);forward(19);
left(7);forward(11);
right(3);forward(13);
right(21);forward(16);
right(22);forward(9);
right(40);forward(12);
left(128);forward(13);
left(15);forward(8);
left(5);forward(11);
left(29);forward(12);
left(18);forward(9);
left(43);forward(5);
left(76);forward(4);
left(62);forward(4);
left(65);forward(9);
left(56);forward(7);
left(3);forward(12);
left(37);forward(13);
left(24);forward(21);
penup();
right(87);forward(8);
done(); // отключить ток в обмотках моторов (отпустить роторы)    
}
/////////////////////////////////////
void komanda_7(){//девушка// цветок
left(143);forward(13);
pendown();
left(172);forward(16);
left(20);forward(14);
left(4);forward(13);
left(9);forward(16);
left(11);forward(17);
forward(18);
left(166);forward(15);
right(2);forward(13);
right(16);forward(12);
right(4);forward(13);
left(3);forward(13);
left(15);forward(10);
left(24);forward(10);
left(63);forward(5);
left(108);forward(6);
left(26);forward(17);
right(9);forward(25);
right(11);forward(21);
right(18);forward(24);
right(15);forward(16);
right(7);forward(12);
right(12);forward(18);
right(130);forward(13);
right(22);forward(10);
right(8);forward(8);
right(22);forward(11);
right(19);forward(11);
right(37);forward(9);
right(48);forward(12);
right(27);forward(15);
right(16);forward(13);
right(16);forward(14);
right(147);forward(20);
left(132);forward(7);
left(3);forward(14);
right(135);forward(11);
penup();
left(27);forward(32);
done(); // отключить ток в обмотках моторов (отпустить роторы)    
}

